// source: src/proto/kernel.proto
/**
 * @fileoverview
 * @enhanceable
 * @suppress {missingRequire} reports error on implicit type usages.
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!
/* eslint-disable */
// @ts-nocheck

var jspb = require('google-protobuf');
var goog = jspb;
var global = Function('return this')();

var shared_kernel_pb = require('../../shared/kernel_pb.js');
goog.object.extend(proto, shared_kernel_pb);
goog.exportSymbol('proto.FromKernel', null, global);
goog.exportSymbol('proto.FromKernel.KindCase', null, global);
goog.exportSymbol('proto.ToKernel', null, global);
goog.exportSymbol('proto.ToKernel.KindCase', null, global);
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ToKernel = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, proto.ToKernel.oneofGroups_);
};
goog.inherits(proto.ToKernel, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ToKernel.displayName = 'proto.ToKernel';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.FromKernel = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, proto.FromKernel.oneofGroups_);
};
goog.inherits(proto.FromKernel, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.FromKernel.displayName = 'proto.FromKernel';
}

/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.ToKernel.oneofGroups_ = [[1,2,3,4]];

/**
 * @enum {number}
 */
proto.ToKernel.KindCase = {
  KIND_NOT_SET: 0,
  EVALUATE: 1,
  PROMPTED: 2,
  CACHED: 3,
  CANCELEVAL: 4
};

/**
 * @return {proto.ToKernel.KindCase}
 */
proto.ToKernel.prototype.getKindCase = function() {
  return /** @type {proto.ToKernel.KindCase} */(jspb.Message.computeOneofCase(this, proto.ToKernel.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ToKernel.prototype.toObject = function(opt_includeInstance) {
  return proto.ToKernel.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ToKernel} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ToKernel.toObject = function(includeInstance, msg) {
  var f, obj = {
    evaluate: (f = msg.getEvaluate()) && shared_kernel_pb.Eval.Code.toObject(includeInstance, f),
    prompted: (f = msg.getPrompted()) && shared_kernel_pb.VSCode.Prompted.toObject(includeInstance, f),
    cached: (f = msg.getCached()) && shared_kernel_pb.VSCode.Cached.toObject(includeInstance, f),
    canceleval: (f = msg.getCanceleval()) && shared_kernel_pb.Eval.Cancel.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ToKernel}
 */
proto.ToKernel.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ToKernel;
  return proto.ToKernel.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ToKernel} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ToKernel}
 */
proto.ToKernel.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new shared_kernel_pb.Eval.Code;
      reader.readMessage(value,shared_kernel_pb.Eval.Code.deserializeBinaryFromReader);
      msg.setEvaluate(value);
      break;
    case 2:
      var value = new shared_kernel_pb.VSCode.Prompted;
      reader.readMessage(value,shared_kernel_pb.VSCode.Prompted.deserializeBinaryFromReader);
      msg.setPrompted(value);
      break;
    case 3:
      var value = new shared_kernel_pb.VSCode.Cached;
      reader.readMessage(value,shared_kernel_pb.VSCode.Cached.deserializeBinaryFromReader);
      msg.setCached(value);
      break;
    case 4:
      var value = new shared_kernel_pb.Eval.Cancel;
      reader.readMessage(value,shared_kernel_pb.Eval.Cancel.deserializeBinaryFromReader);
      msg.setCanceleval(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ToKernel.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ToKernel.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ToKernel} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ToKernel.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getEvaluate();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      shared_kernel_pb.Eval.Code.serializeBinaryToWriter
    );
  }
  f = message.getPrompted();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      shared_kernel_pb.VSCode.Prompted.serializeBinaryToWriter
    );
  }
  f = message.getCached();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      shared_kernel_pb.VSCode.Cached.serializeBinaryToWriter
    );
  }
  f = message.getCanceleval();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      shared_kernel_pb.Eval.Cancel.serializeBinaryToWriter
    );
  }
};


/**
 * optional Eval.Code evaluate = 1;
 * @return {?proto.Eval.Code}
 */
proto.ToKernel.prototype.getEvaluate = function() {
  return /** @type{?proto.Eval.Code} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.Eval.Code, 1));
};


/**
 * @param {?proto.Eval.Code|undefined} value
 * @return {!proto.ToKernel} returns this
*/
proto.ToKernel.prototype.setEvaluate = function(value) {
  return jspb.Message.setOneofWrapperField(this, 1, proto.ToKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ToKernel} returns this
 */
proto.ToKernel.prototype.clearEvaluate = function() {
  return this.setEvaluate(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ToKernel.prototype.hasEvaluate = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional VSCode.Prompted prompted = 2;
 * @return {?proto.VSCode.Prompted}
 */
proto.ToKernel.prototype.getPrompted = function() {
  return /** @type{?proto.VSCode.Prompted} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.VSCode.Prompted, 2));
};


/**
 * @param {?proto.VSCode.Prompted|undefined} value
 * @return {!proto.ToKernel} returns this
*/
proto.ToKernel.prototype.setPrompted = function(value) {
  return jspb.Message.setOneofWrapperField(this, 2, proto.ToKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ToKernel} returns this
 */
proto.ToKernel.prototype.clearPrompted = function() {
  return this.setPrompted(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ToKernel.prototype.hasPrompted = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional VSCode.Cached cached = 3;
 * @return {?proto.VSCode.Cached}
 */
proto.ToKernel.prototype.getCached = function() {
  return /** @type{?proto.VSCode.Cached} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.VSCode.Cached, 3));
};


/**
 * @param {?proto.VSCode.Cached|undefined} value
 * @return {!proto.ToKernel} returns this
*/
proto.ToKernel.prototype.setCached = function(value) {
  return jspb.Message.setOneofWrapperField(this, 3, proto.ToKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ToKernel} returns this
 */
proto.ToKernel.prototype.clearCached = function() {
  return this.setCached(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ToKernel.prototype.hasCached = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional Eval.Cancel cancelEval = 4;
 * @return {?proto.Eval.Cancel}
 */
proto.ToKernel.prototype.getCanceleval = function() {
  return /** @type{?proto.Eval.Cancel} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.Eval.Cancel, 4));
};


/**
 * @param {?proto.Eval.Cancel|undefined} value
 * @return {!proto.ToKernel} returns this
*/
proto.ToKernel.prototype.setCanceleval = function(value) {
  return jspb.Message.setOneofWrapperField(this, 4, proto.ToKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ToKernel} returns this
 */
proto.ToKernel.prototype.clearCanceleval = function() {
  return this.setCanceleval(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ToKernel.prototype.hasCanceleval = function() {
  return jspb.Message.getField(this, 4) != null;
};



/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.FromKernel.oneofGroups_ = [[1,2,3,4,5]];

/**
 * @enum {number}
 */
proto.FromKernel.KindCase = {
  KIND_NOT_SET: 0,
  OUTPUT: 1,
  EVALUATED: 2,
  READCACHE: 3,
  WRITECACHE: 4,
  PROMPT: 5
};

/**
 * @return {proto.FromKernel.KindCase}
 */
proto.FromKernel.prototype.getKindCase = function() {
  return /** @type {proto.FromKernel.KindCase} */(jspb.Message.computeOneofCase(this, proto.FromKernel.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.FromKernel.prototype.toObject = function(opt_includeInstance) {
  return proto.FromKernel.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.FromKernel} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.FromKernel.toObject = function(includeInstance, msg) {
  var f, obj = {
    output: (f = msg.getOutput()) && shared_kernel_pb.Eval.Output.toObject(includeInstance, f),
    evaluated: (f = msg.getEvaluated()) && shared_kernel_pb.Eval.Result.toObject(includeInstance, f),
    readcache: (f = msg.getReadcache()) && shared_kernel_pb.VSCode.ReadCache.toObject(includeInstance, f),
    writecache: (f = msg.getWritecache()) && shared_kernel_pb.VSCode.WriteCache.toObject(includeInstance, f),
    prompt: (f = msg.getPrompt()) && shared_kernel_pb.VSCode.Prompt.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.FromKernel}
 */
proto.FromKernel.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.FromKernel;
  return proto.FromKernel.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.FromKernel} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.FromKernel}
 */
proto.FromKernel.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new shared_kernel_pb.Eval.Output;
      reader.readMessage(value,shared_kernel_pb.Eval.Output.deserializeBinaryFromReader);
      msg.setOutput(value);
      break;
    case 2:
      var value = new shared_kernel_pb.Eval.Result;
      reader.readMessage(value,shared_kernel_pb.Eval.Result.deserializeBinaryFromReader);
      msg.setEvaluated(value);
      break;
    case 3:
      var value = new shared_kernel_pb.VSCode.ReadCache;
      reader.readMessage(value,shared_kernel_pb.VSCode.ReadCache.deserializeBinaryFromReader);
      msg.setReadcache(value);
      break;
    case 4:
      var value = new shared_kernel_pb.VSCode.WriteCache;
      reader.readMessage(value,shared_kernel_pb.VSCode.WriteCache.deserializeBinaryFromReader);
      msg.setWritecache(value);
      break;
    case 5:
      var value = new shared_kernel_pb.VSCode.Prompt;
      reader.readMessage(value,shared_kernel_pb.VSCode.Prompt.deserializeBinaryFromReader);
      msg.setPrompt(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.FromKernel.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.FromKernel.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.FromKernel} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.FromKernel.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getOutput();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      shared_kernel_pb.Eval.Output.serializeBinaryToWriter
    );
  }
  f = message.getEvaluated();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      shared_kernel_pb.Eval.Result.serializeBinaryToWriter
    );
  }
  f = message.getReadcache();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      shared_kernel_pb.VSCode.ReadCache.serializeBinaryToWriter
    );
  }
  f = message.getWritecache();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      shared_kernel_pb.VSCode.WriteCache.serializeBinaryToWriter
    );
  }
  f = message.getPrompt();
  if (f != null) {
    writer.writeMessage(
      5,
      f,
      shared_kernel_pb.VSCode.Prompt.serializeBinaryToWriter
    );
  }
};


/**
 * optional Eval.Output output = 1;
 * @return {?proto.Eval.Output}
 */
proto.FromKernel.prototype.getOutput = function() {
  return /** @type{?proto.Eval.Output} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.Eval.Output, 1));
};


/**
 * @param {?proto.Eval.Output|undefined} value
 * @return {!proto.FromKernel} returns this
*/
proto.FromKernel.prototype.setOutput = function(value) {
  return jspb.Message.setOneofWrapperField(this, 1, proto.FromKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.FromKernel} returns this
 */
proto.FromKernel.prototype.clearOutput = function() {
  return this.setOutput(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.FromKernel.prototype.hasOutput = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional Eval.Result evaluated = 2;
 * @return {?proto.Eval.Result}
 */
proto.FromKernel.prototype.getEvaluated = function() {
  return /** @type{?proto.Eval.Result} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.Eval.Result, 2));
};


/**
 * @param {?proto.Eval.Result|undefined} value
 * @return {!proto.FromKernel} returns this
*/
proto.FromKernel.prototype.setEvaluated = function(value) {
  return jspb.Message.setOneofWrapperField(this, 2, proto.FromKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.FromKernel} returns this
 */
proto.FromKernel.prototype.clearEvaluated = function() {
  return this.setEvaluated(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.FromKernel.prototype.hasEvaluated = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional VSCode.ReadCache readCache = 3;
 * @return {?proto.VSCode.ReadCache}
 */
proto.FromKernel.prototype.getReadcache = function() {
  return /** @type{?proto.VSCode.ReadCache} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.VSCode.ReadCache, 3));
};


/**
 * @param {?proto.VSCode.ReadCache|undefined} value
 * @return {!proto.FromKernel} returns this
*/
proto.FromKernel.prototype.setReadcache = function(value) {
  return jspb.Message.setOneofWrapperField(this, 3, proto.FromKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.FromKernel} returns this
 */
proto.FromKernel.prototype.clearReadcache = function() {
  return this.setReadcache(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.FromKernel.prototype.hasReadcache = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional VSCode.WriteCache writeCache = 4;
 * @return {?proto.VSCode.WriteCache}
 */
proto.FromKernel.prototype.getWritecache = function() {
  return /** @type{?proto.VSCode.WriteCache} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.VSCode.WriteCache, 4));
};


/**
 * @param {?proto.VSCode.WriteCache|undefined} value
 * @return {!proto.FromKernel} returns this
*/
proto.FromKernel.prototype.setWritecache = function(value) {
  return jspb.Message.setOneofWrapperField(this, 4, proto.FromKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.FromKernel} returns this
 */
proto.FromKernel.prototype.clearWritecache = function() {
  return this.setWritecache(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.FromKernel.prototype.hasWritecache = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional VSCode.Prompt prompt = 5;
 * @return {?proto.VSCode.Prompt}
 */
proto.FromKernel.prototype.getPrompt = function() {
  return /** @type{?proto.VSCode.Prompt} */ (
    jspb.Message.getWrapperField(this, shared_kernel_pb.VSCode.Prompt, 5));
};


/**
 * @param {?proto.VSCode.Prompt|undefined} value
 * @return {!proto.FromKernel} returns this
*/
proto.FromKernel.prototype.setPrompt = function(value) {
  return jspb.Message.setOneofWrapperField(this, 5, proto.FromKernel.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.FromKernel} returns this
 */
proto.FromKernel.prototype.clearPrompt = function() {
  return this.setPrompt(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.FromKernel.prototype.hasPrompt = function() {
  return jspb.Message.getField(this, 5) != null;
};


goog.object.extend(exports, proto);
